/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
/**
 * ConfigManager
 * @constructor
 */
function ConfigManager()
{
	var _that			= this;

	_that._config		=
	{
		'acceptedTos':  				false,
		'urlsLinkToNewTab':				true,
		'login':						false,
		'password':						false,
		'activatedDomains':				"",
		'ttl':                  		300,
		'toolbarGUID': 					""			
	};
	
	_that.getConfig		= function()
	{
		return _that._config;
	};
	
	_that.setConfig		= function(config)
	{
		for(var conf in config)
		{
			if(_that._config[conf] != "undefined")
			{
				_that._config[conf]	= config[conf];
				//_that.saveConfig(conf);
			}
		}

		_that.saveConfig(conf);
	};
	
	_that.saveConfig		= function(setting)
	{
		/*
		if(!setting)
		{
			for(var conf in _that._config)
			{
				localStorage[conf]	= _that._config[conf];
			}
		}
		else
		{
			localStorage[setting]	= _that._config[setting];
		}
		*/

		try
		{
			localStorage["com.eNoe.capital-koala.config"] = JSON.stringify(_that._config);
		}
		catch(err)
		{
			//Do nothing
		}
	};
	
	_that._restoreConfig	= function()
	{
		if((localStorage)&&(localStorage["com.eNoe.capital-koala.config"]))
		{
			try
			{
				_that._config = JSON.parse(localStorage["com.eNoe.capital-koala.config"]);
			}
			catch(err)
			{
				//Do nothing
			}
		}
		/**
		for(var conf in _that._config)
		{
			if(localStorage[conf])
			{
				_that._config[conf]	= localStorage[conf];
			}
		}
		**/
	};
	
	_that._restoreConfig();
}

