/**
 * EventManager
 * @constructor
 */

function EventManager(parent)
{
	var _that					= this;
	_that._parent 				= parent;

	_that.sendEvent 			= function(name, parameters)
	{
		var e = 
		{
			"name": 				name,
			"event-guid": 			navigatorAbstractionLayer.generateGuid(),
			"toolbar-guid":			_that._parent.getToolbarGUID(),
			"toolbar-version": 		"2.0.0.0",
			"timestamp" : 			(new Date()).getTime(),
			"parameters": 			parameters
		};

		var serializedEvent = JSON.stringify(e);
		var eventURL = "http://192.168.1.90/events/push/?e="+urlencode(serializedEvent);
		
		try
		{
			navigatorAbstractionLayer.pokeURL(eventURL);
		}
		catch(err)
		{
			//Do nothing
		}
	};

	_that.sendRawTrackingActivationEvent			= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("RAW_TRACKING_ACTIVATION", parameters);
	};

	_that.sendToolbarTrackingLinkClickedEvent 		= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("TOOLBAR_TRACKING_LINK_CLICKED", parameters);
	};

	_that.sendOpenProgramUrlEvent 					= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("PROGRAM_URL_OPENED", parameters);
	};

	_that.sendTrackingAutoActivatedEvent 			= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("TRACKING_AUTO_ACTIVATED", parameters);
	};
}

