function urlencode (str) {
    // http://kevin.vanzonneveld.net
    // +   original by: Philip Peterson
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: AJ
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: travc
    // +      input by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Lars Fischer
    // +      input by: Ratheous
    // +      reimplemented by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Joris
    // +      reimplemented by: Brett Zamir (http://brett-zamir.me)
    // %          note 1: This reflects PHP 5.3/6.0+ behavior
    // %        note 2: Please be aware that this function expects to encode into UTF-8 encoded strings, as found on
    // %        note 2: pages served as UTF-8
    // *     example 1: urlencode('Kevin van Zonneveld!');
    // *     returns 1: 'Kevin+van+Zonneveld%21'
    // *     example 2: urlencode('http://kevin.vanzonneveld.net/');
    // *     returns 2: 'http%3A%2F%2Fkevin.vanzonneveld.net%2F'
    // *     example 3: urlencode('http://www.google.nl/search?q=php.js&ie=utf-8&oe=utf-8&aq=t&rls=com.ubuntu:en-US:unofficial&client=firefox-a');
    // *     returns 3: 'http%3A%2F%2Fwww.google.nl%2Fsearch%3Fq%3Dphp.js%26ie%3Dutf-8%26oe%3Dutf-8%26aq%3Dt%26rls%3Dcom.ubuntu%3Aen-US%3Aunofficial%26client%3Dfirefox-a'

    str = (str+'').toString();
    
    // Tilde should be allowed unescaped in future versions of PHP (as reflected below), but if you want to reflect current
    // PHP behavior, you would need to add ".replace(/~/g, '%7E');" to the following.
    return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').
                                                                    replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
}


/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
function SessionManager(ttl, onConnect, onConnectArgs, onDisconnect, onDisconnectArgs)
{
  var _that                  = this;

  _that.ttl                  = ttl;
  _that._lastFetchDate       = 0;
  _that._userInfo            = null;
  _that.onConnectArgs        = onConnectArgs;
  _that.onConnect            = onConnect;
  _that.onDisconnectArgs     = onDisconnectArgs;
  _that.onDisconnect         = onDisconnect;
//--------------------------------------------------------------
//--------------------------------------------------------------
  _that.disconnect       = function()
  {
    if(_that._userInfo)
    {
      wget
      (
        "http://www.capitalkoala.com/api/auth/logout/",
        
        function(response, _this)
        {
          _that.onDisconnect(_that._userInfo, _that.onDisconnectArgs);
          _that._userInfo = null;
        },
        
        _that
      );
    }
  };
//--------------------------------------------------------------
  _that.connect          = function(login, password, callback, callbackArgs)
  {
    _that.disconnect();

  
    wget
    (
      "http://www.capitalkoala.com/api/auth/login/?login=" + urlencode(login) + "&password=" + urlencode(password),
      
      function(response, args)
      {
        if((response)&&(response['id']))
        {
          _that._userInfo = response;
          
          _that.onConnect(_that._userInfo, _that.onConnectArgs);
          args['callback'](true, args['callbackArgs']);
        }
        else
        {
          args['callback'](false, args['callbackArgs']);
        }
      },
      
      {
        '_this':          _that,
        'callback':       callback,
        'callbackArgs':   callbackArgs
      }
    );
  };
//--------------------------------------------------------------
  _that.isUserConnected      = function(callback, args)
  {
    //Get the time to check the ttl
    var currentTime = Math.round(new Date().getTime() / 1000);

    if(currentTime > (_that._lastFetchDate + _that.ttl))
    {
      _that._lastFetchDate = currentTime;
      
      //If the ttl is expired, perform a server request
      wget
      (
        "http://www.capitalkoala.com/api/auth/status/",
        
        function(response, _this)
        {
          if((response)&&(response['id']))
          {
            _that._userInfo = response;         
            
            callback(true, args);
          }
          else
          {
            _that.disconnect();
            callback(false, args);
          }
        },
        
        _that
      );
    }
    else
    {
      //Else, check internally
      callback((!(!_that._userInfo)), args);
    }
   
  };
//--------------------------------------------------------------
  _that.getUserId        = function()
  {
    var id = 0;
    
    if(_that._userInfo)
    {
      id = _that._userInfo.id;
    }
    
    return id;
  };
//--------------------------------------------------------------
  _that.getUserInfo      = function()
  {
    return _that._userInfo;
  };
//--------------------------------------------------------------
//--------------------------------------------------------------
}

